=== debian/watch ===
version=3

# This package is version 2.21-specific, we're only interested in
# minor updates
opts=uversionmangle=s/-src$//;s/-beta/~beta/,dversionmangle=s/.dfsg.*$// \
http://sf.net/wine/wine-mozilla-(2\.21.*)\.tar\.bz2 debian python debian/repack.py
